Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.map
Class CompositeMap

    java.lang.Object
      org.apache.commons.collections.map.CompositeMap

All Implemented Interfaces:
  java.util.Map

    public class CompositeMap

extends java.lang.Object
implements java.util.Map

Decorates a map of other maps to provide a single unified view.

Changes made to this map will actually be made on the decorated map. Add and remove operations require the use of a pluggable strategy. If no strategy is provided then add and remove are unsupported.

Note that CompositeMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

Since:
  Commons Collections 3.0
Version:
  $Revision: 647116 $ $Date: 2008-04-11 12:23:08 +0100 (Fri, 11 Apr 2008) $
Author:
  Brian McCallister

Nested Class Summary
`static interface` | `CompositeMap.MapMutator` This interface allows definition for all of the indeterminate mutators in a CompositeMap, as well as providing a hook for callbacks on key collisions.

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Constructor Summary
`CompositeMap()` Create a new, empty, CompositeMap.
`CompositeMap(java.util.Map[] composite)` Create a new CompositeMap which composites all of the Map instances in the argument.
`CompositeMap(java.util.Map[] composite, CompositeMap.MapMutator mutator)` Create a new CompositeMap which composites all of the Map instances in the argument.
`CompositeMap(java.util.Map one, java.util.Map two)` Create a new CompositeMap with two composited Map instances.
`CompositeMap(java.util.Map one, java.util.Map two, CompositeMap.MapMutator mutator)` Create a new CompositeMap with two composited Map instances.

Method Summary
`void` | `addComposited(java.util.Map map)` Add an additional Map to the composite.
`void` | `clear()` Calls `clear()` on all composited Maps.
`boolean` | `containsKey(java.lang.Object key)` Returns `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(java.lang.Object value)` Returns `true` if this map maps one or more keys to the specified value.
`java.util.Set` | `entrySet()` Returns a set view of the mappings contained in this map.
`boolean` | `equals(java.lang.Object obj)` Checks if this Map equals another as per the Map specification.
`java.lang.Object` | `get(java.lang.Object key)` Returns the value to which this map maps the specified key.
`int` | `hashCode()` Gets a hash code for the Map as per the Map specification.
`boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
`java.util.Set` | `keySet()` Returns a set view of the keys contained in this map.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Associates the specified value with the specified key in this map (optional operation).
`void` | `putAll(java.util.Map map)` Copies all of the mappings from the specified map to this map (optional operation).
`java.lang.Object` | `remove(java.lang.Object key)` Removes the mapping for this key from this map if it is present (optional operation).
`java.util.Map` | `removeComposited(java.util.Map map)` Remove a Map from the composite.
`void` | `setMutator(CompositeMap.MapMutator mutator)` Specify the MapMutator to be used by mutation operations.
`int` | `size()` Returns the number of key-value mappings in this map.
`java.util.Collection` | `values()` Returns a collection view of the values contained in this map.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CompositeMap

    public CompositeMap()

  Create a new, empty, CompositeMap.

### CompositeMap

    public CompositeMap(java.util.Map one,
                        java.util.Map two)

  Create a new CompositeMap with two composited Map instances.

  Parameters:
    `one` - the first Map to be composited
    `two` - the second Map to be composited
  Throws:
    `java.lang.IllegalArgumentException` - if there is a key collision

### CompositeMap

    public CompositeMap(java.util.Map one,
                        java.util.Map two,
                        CompositeMap.MapMutator mutator)

  Create a new CompositeMap with two composited Map instances.

  Parameters:
    `one` - the first Map to be composited
    `two` - the second Map to be composited
    `mutator` - MapMutator to be used for mutation operations

### CompositeMap

    public CompositeMap(java.util.Map[] composite)

  Create a new CompositeMap which composites all of the Map instances in the argument. It copies the argument array, it does not use it directly.

  Parameters:
    `composite` - the Maps to be composited
  Throws:
    `java.lang.IllegalArgumentException` - if there is a key collision

### CompositeMap

    public CompositeMap(java.util.Map[] composite,
                        CompositeMap.MapMutator mutator)

  Create a new CompositeMap which composites all of the Map instances in the argument. It copies the argument array, it does not use it directly.

  Parameters:
    `composite` - Maps to be composited
    `mutator` - MapMutator to be used for mutation operations

Method Detail

### setMutator

    public void setMutator(CompositeMap.MapMutator mutator)

  Specify the MapMutator to be used by mutation operations.

  Parameters:
    `mutator` - the MapMutator to be used for mutation delegation

### addComposited

    public void addComposited(java.util.Map map)
                       throws java.lang.IllegalArgumentException

  Add an additional Map to the composite.

  Parameters:
    `map` - the Map to be added to the composite
  Throws:
    `java.lang.IllegalArgumentException` - if there is a key collision and there is no MapMutator set to handle it.

### removeComposited

    public java.util.Map removeComposited(java.util.Map map)

  Remove a Map from the composite.

  Parameters:
    `map` - the Map to be removed from the composite
  Returns:
    The removed Map or `null` if map is not in the composite

### clear

    public void clear()

  Calls `clear()` on all composited Maps.

  Specified by:
    `clear` in interface `java.util.Map`
  Throws:
    `java.lang.UnsupportedOperationException` - if any of the composited Maps do not support clear()

### containsKey

    public boolean containsKey(java.lang.Object key)

  Returns `true` if this map contains a mapping for the specified key. More formally, returns `true` if and only if this map contains at a mapping for a key `k` such that `(key==null ? k==null : key.equals(k))`. (There can be at most one such mapping.)

  Specified by:
    `containsKey` in interface `java.util.Map`
  Parameters:
    `key` - key whose presence in this map is to be tested.
  Returns:
    `true` if this map contains a mapping for the specified key.
  Throws:
    `java.lang.ClassCastException` - if the key is of an inappropriate type for this map (optional).
    `java.lang.NullPointerException` - if the key is `null` and this map does not not permit `null` keys (optional).

### containsValue

    public boolean containsValue(java.lang.Object value)

  Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `(value==null ? v==null : value.equals(v))`. This operation will probably require time linear in the map size for most implementations of the `Map` interface.

  Specified by:
    `containsValue` in interface `java.util.Map`
  Parameters:
    `value` - value whose presence in this map is to be tested.
  Returns:
    `true` if this map maps one or more keys to the specified value.
  Throws:
    `java.lang.ClassCastException` - if the value is of an inappropriate type for this map (optional).
    `java.lang.NullPointerException` - if the value is `null` and this map does not not permit `null` values (optional).

### entrySet

    public java.util.Set entrySet()

  Returns a set view of the mappings contained in this map. Each element in the returned set is a `Map.Entry`. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.

  This implementation returns a `CompositeSet` which composites the entry sets from all of the composited maps.

  Specified by:
    `entrySet` in interface `java.util.Map`
  Returns:
    a set view of the mappings contained in this map.
  See Also:
    `CompositeSet`

### get

    public java.lang.Object get(java.lang.Object key)

  Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.

  More formally, if this map contains a mapping from a key `k` to a value `v` such that `(key==null ? k==null : key.equals(k))`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

  Specified by:
    `get` in interface `java.util.Map`
  Parameters:
    `key` - key whose associated value is to be returned.
  Returns:
    the value to which this map maps the specified key, or `null` if the map contains no mapping for this key.
  Throws:
    `java.lang.ClassCastException` - if the key is of an inappropriate type for this map (optional).
    `java.lang.NullPointerException` - key is `null` and this map does not not permit `null` keys (optional).
  See Also:
    `containsKey(Object)`

### isEmpty

    public boolean isEmpty()

  Returns `true` if this map contains no key-value mappings.

  Specified by:
    `isEmpty` in interface `java.util.Map`
  Returns:
    `true` if this map contains no key-value mappings.

### keySet

    public java.util.Set keySet()

  Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll` `retainAll`, and `clear` operations. It does not support the add or `addAll` operations.

  This implementation returns a `CompositeSet` which composites the key sets from all of the composited maps.

  Specified by:
    `keySet` in interface `java.util.Map`
  Returns:
    a set view of the keys contained in this map.

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Associates the specified value with the specified key in this map (optional operation). If the map previously contained a mapping for this key, the old value is replaced by the specified value. (A map `m` is said to contain a mapping for a key `k` if and only if `m.containsKey(k)` would return `true`.))

  Specified by:
    `put` in interface `java.util.Map`
  Parameters:
    `key` - key with which the specified value is to be associated.
    `value` - value to be associated with the specified key.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key, if the implementation supports `null` values.
  Throws:
    `java.lang.UnsupportedOperationException` - if no MapMutator has been specified
    `java.lang.ClassCastException` - if the class of the specified key or value prevents it from being stored in this map.
    `java.lang.IllegalArgumentException` - if some aspect of this key or value prevents it from being stored in this map.
    `java.lang.NullPointerException` - this map does not permit `null` keys or values, and the specified key or value is `null`.

### putAll

    public void putAll(java.util.Map map)

  Copies all of the mappings from the specified map to this map (optional operation). The effect of this call is equivalent to that of calling `put(k, v)` on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is unspecified if the specified map is modified while the operation is in progress.

  Specified by:
    `putAll` in interface `java.util.Map`
  Parameters:
    `map` - Mappings to be stored in this map.
  Throws:
    `java.lang.UnsupportedOperationException` - if the `putAll` method is not supported by this map.
    `java.lang.ClassCastException` - if the class of a key or value in the specified map prevents it from being stored in this map.
    `java.lang.IllegalArgumentException` - some aspect of a key or value in the specified map prevents it from being stored in this map.
    `java.lang.NullPointerException` - the specified map is `null`, or if this map does not permit `null` keys or values, and the specified map contains `null` keys or values.

### remove

    public java.lang.Object remove(java.lang.Object key)

  Removes the mapping for this key from this map if it is present (optional operation). More formally, if this map contains a mapping from key `k` to value `v` such that `(key==null ? k==null : key.equals(k))`, that mapping is removed. (The map can contain at most one such mapping.)

  Returns the value to which the map previously associated the key, or `null` if the map contained no mapping for this key. (A `null` return can also indicate that the map previously associated `null` with the specified key if the implementation supports `null` values.) The map will not contain a mapping for the specified key once the call returns.

  Specified by:
    `remove` in interface `java.util.Map`
  Parameters:
    `key` - key whose mapping is to be removed from the map.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key.
  Throws:
    `java.lang.ClassCastException` - if the key is of an inappropriate type for the composited map (optional).
    `java.lang.NullPointerException` - if the key is `null` and the composited map does not not permit `null` keys (optional).
    `java.lang.UnsupportedOperationException` - if the `remove` method is not supported by the composited map containing the key

### size

    public int size()

  Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `java.util.Map`
  Returns:
    the number of key-value mappings in this map.

### values

    public java.util.Collection values()

  Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. If the map is modified while an iteration over the collection is in progress, the results of the iteration are undefined. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the add or `addAll` operations.

  Specified by:
    `values` in interface `java.util.Map`
  Returns:
    a collection view of the values contained in this map.

### equals

    public boolean equals(java.lang.Object obj)

  Checks if this Map equals another as per the Map specification.

  Specified by:
    `equals` in interface `java.util.Map`
  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object to compare to
  Returns:
    true if the maps are equal

### hashCode

    public int hashCode()

  Gets a hash code for the Map as per the Map specification.

  Specified by:
    `hashCode` in interface `java.util.Map`
  Overrides:
    `hashCode` in class `java.lang.Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.